<template>


  <header class="section-header" style="margin-top: -60px">

      <nav class="navbar navbar-expand-lg header-main">
        <router-link :to="{ name: 'home' }" class="text-decoration-none" data-abc="true">
          <span class="logo">GREENK SHOP </span>
        </router-link>
        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarNav"
          aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
          <i class="fas fa-bars text-white"></i>
        </button>
        <div class="collapse navbar-collapse" id="navbarNav">
          <ul class="navbar-nav ml-auto">
            <li class="nav-item mb-2 mb-2 mb-lg-0">
              <div class="cart-header text-left">
                <router-link :to="{ name: 'cart' }" href="#" class="btn search-button btn-md">
                  <i class="fa fa-shopping-cart"></i>
                  {{ cartCount }} | Rp {{ moneyFormat(cartTotal) }}
                </router-link>
              </div>
            </li>


            <li class="nav-item ">
              <div class="account text-left">
                <router-link :to="{ name: 'login' }" v-if="!isLoggedIn" class="btn search-button btn-md ml-lg-4">Login |
                  Register
                </router-link>
                <router-link :to="{ name: 'dashboard' }" v-else class="btn search-button btn-md ml-lg-4">
                  <i class="fa fa-user-circle"></i>
                  Dashboard
                </router-link>
              </div>
            </li>
          </ul>
        </div>
      </nav>
    </header>
</template>

<script>
import Api from "../api/Api";
import { computed, onMounted, reactive } from 'vue';
import { useStore } from 'vuex';
export default {
  name: 'HeaderComponent',

  setup() {
    // stoer vuex 
    const store = useStore()

    const state = reactive({
      keywords: ''
    })

    // computed
    const isLoggedIn = computed(() => {
      //get getters isLoggedIn dari module auth
      return store.getters['auth/isLoggedIn']
    })

    //cart count
    const cartCount = computed(() => {

      //get getter "cartCount" dari module "auth"
      return store.getters['cart/cartCount']
    })

    //cart total
    const cartTotal = computed(() => {

      //get getter "cartTotal" dari module "auth"
      return store.getters['cart/cartTotal']
    })

    // mounted 
    onMounted(() => {
      // check state token
      const token = store.state.auth.token

      if (!token) {
        return;
      }
      // saat mounted, akan memanggil action "cartCount" di module "cart"
      store.dispatch('cart/cartCount');

      // ssat mounted, akan memanggil action "cartTotal" di module "cart"
      store.dispatch('cart/cartTotal');
    });


    function searchProducts() {
      Api.get("/products/search?keywrodsad=", { keywords: state.keywords })
        .then(response => {
          if (response.data === 'ok') {
            console.log('request sent successfully');
          }
        }).catch(error => {
          console.log(error);
        })
    }
    return {
      store,
      isLoggedIn,
      cartCount,
      cartTotal,
      state,
      searchProducts
    }
  }
}
</script>


<style scoped>
.navbar-toggler:focus,
.navbar-toggler:active,
.navbar-toggler-icon:focus {
  outline:  none;
  box-shadow: none;
}
</style>